#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire900eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight9004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight9004xi = {
                1:'-101x-692y-565z',
                2:'-103x-309y-838z',
                3:'-108x-182y-874z',
                4:'-112x-886y-107z',
                5:'-122x-311y-835z',
                6:'-123x-183y-872z',
                7:'-125x-605y-653z',
                8:'-137x-183y-870z',
                9:'-138x-691y-558z',
                10:'-141x-312y-832z',
                11:'-152x-182y-867z',
                12:'-158x-604y-647z',
                13:'-159x-880y-98z',
                14:'-161x-311y-828z',
                15:'-168x-181y-865z',
                16:'-16x-140y-888z',
                17:'-176x-688y-551z',
                18:'-182x-310y-825z',
                19:'-183x-177y-862z',
                20:'-192x-601y-641z',
                21:'-199x-173y-860z',
                22:'-19x-890y-125z',
                23:'-1x-123y-891z',
                24:'-202x-306y-821z',
                25:'-205x-871y-89z',
                26:'-213x-683y-544z',
                27:'-214x-168y-857z',
                28:'-223x-302y-817z',
                29:'-225x-596y-634z',
                30:'-230x-161y-854z',
                31:'-243x-296y-813z',
                32:'-245x-154y-852z',
                33:'-250x-860y-80z',
                34:'-251x-676y-537z',
                35:'-258x-590y-628z',
                36:'-25x-148y-887z',
                37:'-260x-145y-849z',
                38:'-264x-289y-810z',
                39:'-275x-135y-846z',
                40:'-285x-280y-806z',
                41:'-288x-667y-530z',
                42:'-28x-598y-671z',
                43:'-28x-687y-579z',
                44:'-290x-123y-842z',
                45:'-292x-581y-621z',
                46:'-295x-846y-71z',
                47:'-303x-111y-839z',
                48:'-305x-270y-802z',
                49:'-317x-97y-836z',
                50:'-325x-259y-797z',
                51:'-325x-570y-615z',
                52:'-325x-656y-522z',
                53:'-330x-83y-833z',
                54:'-340x-830y-62z',
                55:'-342x-67y-829z',
                56:'-345x-246y-793z',
                57:'-353x-50y-826z',
                58:'-358x-557y-608z',
                59:'-35x-155y-885z',
                60:'-361x-643y-515z',
                61:'-363x-32y-822z',
                62:'-364x-232y-789z',
                63:'-36x-322y-945z',
                64:'-382x-217y-785z',
                65:'-383x-812y-53z',
                66:'-390x-543y-602z',
                67:'-397x-627y-508z',
                68:'-400x-200y-780z',
                69:'-417x-182y-776z',
                70:'-422x-526y-595z',
                71:'-425x-791y-44z',
                72:'-432x-610y-500z',
                73:'-433x-162y-771z',
                74:'-449x-142y-766z',
                75:'-452x-508y-588z',
                76:'-45x-161y-884z',
                77:'-463x-120y-762z',
                78:'-466x-768y-35z',
                79:'-467x-590y-493z',
                80:'-483x-488y-581z',
                81:'-49x-296y-848z',
                82:'-500x-568y-485z',
                83:'-506x-743y-26z',
                84:'-512x-466y-574z',
                85:'-533x-545y-477z',
                86:'-540x-442y-567z',
                87:'-544x-716y-17z',
                88:'-564x-519y-470z',
                89:'-567x-416y-560z',
                90:'-57x-167y-882z',
                91:'-581x-686y-8z',
                92:'-592x-389y-553z',
                93:'-594x-492y-462z',
                94:'-60x-602y-665z',
                95:'-616x-655y0z',
                96:'-617x-360y-546z',
                97:'-623x-463y-454z',
                98:'-640x-330y-539z',
                99:'-64x-691y-572z',
                100:'-650x-432y-447z',
                101:'-661x-298y-532z',
                102:'-66x-302y-845z',
                103:'-66x-889y-116z',
                104:'-675x-400y-439z',
                105:'-681x-265y-524z',
                106:'-699x-231y-517z',
                107:'-699x-366y-431z',
                108:'-69x-172y-880z',
                109:'-715x-195y-510z',
                110:'-721x-331y-423z',
                111:'-729x-159y-502z',
                112:'-741x-121y-495z',
                113:'-742x-294y-415z',
                114:'-751x-82y-487z',
                115:'-760x-256y-407z',
                116:'-776x-217y-399z',
                117:'-790x-177y-391z',
                118:'-81x-176y-878z',
                119:'-84x-306y-842z',
                120:'-8x-132y-890z',
                121:'-92x-605y-659z',
                122:'-95x-179y-876z'}                         

#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire900eight4xi" usage = "target function for charge900eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire900eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE900EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE900EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE900EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE900EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE900EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight9004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE900EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE900EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE900EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight9004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight9004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE900EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE900EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE900EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire900eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  